#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include "contracts.h"

int square(int a) {
  return a * a;
}
int add1(int a) {
  return a + 1;
}
void map(int (*f)(int), int A[], size_t n) {
  for (size_t i = 0; i < n; i++) {
    A[i] = f(A[i]);
  }
}

void print_arr(int A[], size_t n) {
  for (size_t i = 0; i < n - 1; i++) {
    printf("%d, ", A[i]);
  }
  printf("%d\n", A[n - 1]);
}

typedef void* elem;
typedef int (*compare_fun)(elem, elem);
//int min_index(elem *A, int lower, int upper, int *elem_compare(elem, elem)) {
int min_index(elem *A, int lower, int upper, compare_fun elem_compare) {
  REQUIRES(A != NULL && 0 <= lower && lower < upper && elem_compare != NULL);
  int min_idx = lower;
  for (int i = lower + 1; i < upper; i++) {
    if ((*elem_compare)(A[i], A[min_idx]) < 0) {
      min_idx = i;
    }
  }
  return min_idx;
}

int cmp(elem x, elem y) {
  int a = (int)(intptr_t)x;
  int b = (int)(intptr_t)y;
  return a - b;
}

int main() {
  int A[5] = {0,1,2,3,4};
  printf("Initially: ");
  print_arr(A, 5);
  printf("Squared:   ");
  map(square, A, 5);
  print_arr(A, 5);
  map(add1, A, 5);
  printf("Add one:   ");
  print_arr(A, 5);

  elem B[5] = {(elem)12, (elem)15, (elem)7, (elem)3, (elem)10};
  printf("\nMin index in B: %d\n", min_index(B, 0, 5, &cmp));
  return 0;
}

